﻿
using System;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Threading;
using Newtonsoft.Json;
using Newtonsoft.Json.Linq;
using System.Net;
using System.Net.Sockets;
using System.Net.Mime;
using System.Drawing;

namespace httpListener
{
    public partial class Main : Form
    {
        public Main()
        {
            InitializeComponent();
            txtDireccionIp.Text = GetLocalIP();
        }

        Thread hilo1;
        HttpListener listener;
        string historico;
        int contador = 1;

        public void btnIniciar_Click(object sender, EventArgs e)
        {
            hilo1 = new Thread(recibirEventosHttp);
            hilo1.Start();
        }

        public void btnDetener_Click(object sender, EventArgs e)
        {
            btnDetener.Enabled = false;
            btnIniciar.Enabled = true;
            txtPuerto.Enabled = true;
            txtRuta.Enabled = true;
            txtDireccionIp.Enabled = true;
            txtEstatus.Text = "Servicio detenido";
            hilo1.Abort();
            listener.Abort();
        }


        public static string GetLocalIP()
        {
            try
            {
                string HostName = Dns.GetHostName();
                IPHostEntry IpEntry = Dns.GetHostEntry(HostName);
                for (int i = 0; i < IpEntry.AddressList.Length; i++)
                {
                    if (IpEntry.AddressList[i].AddressFamily == AddressFamily.InterNetwork)
                    {
                        return IpEntry.AddressList[i].ToString();
                    }
                }
                return "";
            }
            catch (Exception ex)
            {
                MessageBox.Show("Get Local IP Address Error:" + ex.Message, "", MessageBoxButtons.OK, MessageBoxIcon.Error);
                return "";
            }
        }

        public void ExtrarImagem(string documentContents, int total_bytes, byte[] request_bytes)
        {
            string palabraClave = "Content-ID: pictureImage";
            string imagen = null;

            // Divide la cadena utilizando la palabra clave como delimitador
            string[] partes = documentContents.Split(new string[] { palabraClave }, StringSplitOptions.None);

            if (partes.Length > 1)
            {
                // Imprime las partes resultantes
                Console.WriteLine("Parte 1: " + partes[0] + palabraClave);
                imagen = partes[1].Trim();
            }

            byte[] utf8Bytes = Encoding.UTF8.GetBytes(imagen);


            int lenght = StringUtility.ExtractImageLenghtFromRequest(documentContents);

            int skip_bytes = total_bytes - lenght;
            int take_bytes = total_bytes - skip_bytes;




            // Starting position to split the byte array
            int startingPosition = skip_bytes;



            byte[] fotoReal = new byte[lenght];

            //Restamos 20 bytes por que al final esta el texto de --MIME_boundary
            int starting_point = total_bytes - lenght - 20;


            for (int i = 0; i < lenght; i++)
            {
                fotoReal[i] = request_bytes[starting_point - 1 + i];
            }



            // Ahora puedes trabajar con la imagen (guardarla, procesarla, etc.)
            File.WriteAllBytes("foto_" + contador + ".jpg", fotoReal);

            this.Invoke(new Action(() => pcbFoto.Image = Image.FromFile(Application.StartupPath + "\\foto_" + contador + ".jpg")));

            contador++;
        }

        public void recibirEventosHttp()
        {
            listener = new HttpListener();
            var url = "";
            if (txtRuta.Text == "")
            {
                url = "http://" + txtDireccionIp.Text + ":" + txtPuerto.Text + "/";
            }
            else
            {
                url = "http://" + txtDireccionIp.Text + ":" + txtPuerto.Text + "/" + txtRuta.Text + "/";
            }

            listener.Prefixes.Add(url);
            listener.Start();

            this.Invoke(new Action(() => btnDetener.Enabled = true));
            this.Invoke(new Action(() => btnIniciar.Enabled = false));
            this.Invoke(new Action(() => txtPuerto.Enabled = false));
            this.Invoke(new Action(() => txtRuta.Enabled = false));
            this.Invoke(new Action(() => txtDireccionIp.Enabled = false));

            if (txtRuta.Text == "")
            {
                this.Invoke(new Action(() => txtEstatus.Text = "Escuchando --> http://" + txtDireccionIp.Text + ":" + txtPuerto.Text + "/"));
            }
            else
            {
                this.Invoke(new Action(() => txtEstatus.Text = "Escuchando --> http://" + txtDireccionIp.Text + ":" + txtPuerto.Text + "/" + txtRuta.Text + "/"));
            }

            while (true)
            {
                HttpListenerContext context = listener.GetContext();
                HttpListenerRequest request = context.Request;

                Stream receiveStream = request.InputStream;

                MemoryStream _ms = new MemoryStream();
                receiveStream.CopyTo(_ms);

                byte[] request_bytes = _ms.GetBuffer();

                int total_bytes = request_bytes.Length;

                MemoryStream stream = new MemoryStream(request_bytes);


                string documentContents;

     
                using (StreamReader readStream = new StreamReader(stream, Encoding.UTF8))
                {
                    documentContents = readStream.ReadToEnd();
                }



                this.Invoke(new Action(() => historico = txtDatos.Text));
                this.Invoke(new Action(() => historico = "\n" + documentContents + "\n---------------------------------------------------------------------------------------------------------------------------------------------\n" + txtDatos.Text));
                this.Invoke(new Action(() => txtDatos.Text = historico));



                dynamic dynamicObject = null;

                //Si hay imagen vamos a decodificar
                if (documentContents.Contains("Content-Disposition: form-data; name=\"event_log\""))
                {
                    string json = StringUtility.ExtractJsonFromRequest(documentContents);
                    if(json != null)
                        dynamicObject = JsonConvert.DeserializeObject<System.Dynamic.ExpandoObject>(json);

                    //Ejemplo
                    System.Console.WriteLine("IP Address: " + dynamicObject.ipAddress);

                }
               
                    //Si hay imagen vamos a decodificar
                if (documentContents.Contains("Content-ID: pictureImage"))
                {
                    ExtrarImagem(documentContents,total_bytes,request_bytes);
                }

                /* ----------------------------------------------------------- */
                //deserealización, inserción, etc.
                /* ----------------------------------------------------------- */

                HttpListenerResponse response = context.Response;
                string responseString = "200";
                byte[] buffer = System.Text.Encoding.UTF8.GetBytes(responseString);
                response.ContentLength64 = buffer.Length;
                System.IO.Stream output = response.OutputStream;
                output.Write(buffer, 0, buffer.Length);
                output.Close();
            }
        }
    }
}