﻿using System.IO;

public class MultipartParser
{
    public bool Success { get; private set; }
    public string Boundary { get; private set; }
    public string Key { get; private set; }
    public string Filename { get; private set; }
    public byte[] FileContents { get; private set; }

    public MultipartParser(Stream stream, string boundary)
    {
        try
        {
            this.Success = false;
            this.Boundary = "--" + boundary;

            System.IO.StreamReader reader = new System.IO.StreamReader(stream);

            // Lee la primera línea y la ignora
            reader.ReadLine();

            // Lee la segunda línea y la ignora
            reader.ReadLine();

            // Lee la tercera línea y la guarda como clave
            this.Key = reader.ReadLine().Split(' ')[1].Replace("\"", "");

            // Lee la cuarta línea y la guarda como nombre de archivo
            this.Filename = reader.ReadLine().Split(' ')[1].Replace("\"", "");

            // Lee la quinta línea (vacía) y la ignora
            reader.ReadLine();

            // Lee el contenido del archivo hasta el final de la solicitud
            MemoryStream ms = new MemoryStream();
            byte[] buffer = new byte[4096];
            int bytesRead;
            while ((bytesRead = stream.Read(buffer, 0, buffer.Length)) != 0)
            {
                ms.Write(buffer, 0, bytesRead);
            }

            this.FileContents = ms.ToArray();
            this.Success = true;
        }
        catch
        {
            this.Success = false;
        }
    }
}